<?php
/*
 * This file is part of Web Pro Manager.
 * 
 * Web Pro Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Web Pro Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Web Pro Manager.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author The Web Pro Miami, Inc. <info@thewebpro.com>
 * @copyright The Web Pro Miami, Inc. <info@thewebpro.com>, http://www.thewebpro.com/
 * @license http://www.gnu.org/licenses/gpl.html GNU GPL
 * @package WebProManager
*/

require("../inc/stop_cache.php");
$nAdminOnlyPg = 0;
require("../inc/secure_page.php");
// connect to mysql
require("../../inc/dbconnect.php");
require("../inc/langutil.php");

// config
$nRefreshCall = "refreshPageComps();";

// pull in all active languages (used to create multiple fields, when needed)
$nActiveLangARRAY = nGetLangActiveARRAY();

// Get passed-in vars
$nRecID = $_GET["id"];
if(!$nRecID){ $nRecID = $_POST["id"]; }

// AJAX Specific vars
$nPassThru = "";
$nDivToUpdate = "editModal";
$nPageInDiv = "dialog/component_duplicate.php";

// Get additional data
if($nRecID){
	$nSQL = "SELECT * FROM xComponentPage WHERE nID=$nRecID";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nContentID = $Row["nContentID"];
		$nCompID = $Row["nComponentID"];
		$nPageID = $Row["nPageID"];
		$nColumnID = $Row["nColumnID"];
		$nXCompOrderID = $Row["nOrderID"];
		$nCompTitle = nGetComponentName($nCompID);
	}
}
?>

<div id="<?=$nDivToUpdate;?>">

<?php
include("../inc/form_class.php");

$nFormName = "FormCompEdit";
$nForm1 = new Form();
//$nForm1->DEBUG = true;
$nForm1->Name = $nFormName;
$nForm1->Action = $_SERVER['PHP_SELF'];
$nForm1->CancelText = "Cancel";
$nForm1->CancelRedirect = "$.colorbox.close()";
$nForm1->CancelRedirectIsJS = true;
$nForm1->SubmitText = "Duplicate";
//$nForm1->AddToDBTable = "xComponentPage";
$nForm1->DontProcess = "id";

$nForm1->DBLink = $Link;
$nForm1->nUseADODB = false;
// AJAX settings
$nForm1->SubmitIsJS = true;
$nForm1->SubmitToJS = "return submitForm('$nDivToUpdate','$nPageInDiv$nPassThru','$nFormName');return false;";

// Create groups
$nFormGroup1 = new FormGroup();

// Create fields
$nFormField = new FormField("hidden","id");
$nFormField->Value = $nRecID;
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("hidden","nComponentID");
$nFormField->Value = $nCompID;
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("hidden","nPageID");
$nFormField->Value = $nPageID;
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("hidden","nColumnID");
$nFormField->Value = $nColumnID;
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("hidden","nContentID");
$nFormField->Value = $nContentID;
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("hidden","nXCompOrderID");
$nFormField->Value = $nXCompOrderID;
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("multiSelect","nPageID","Duplicate this component to page:");
$nFormField->Caption = "Hold down CTRL to select multiple pages.";
$nFormField->DataARRAY = nGetPageARRAY();
if($nLinkID){
	$nFormField->SelectedARRAY = array("$nPageID" => "selected");
} else {
	$nFormField->SelectedARRAY = array("0" => "selected"); // default
}
$nFormField->RowSize = "Half";
$nFormField->Style = "width:360px;height:240px;";
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("radio","nDupType","Duplicate Type:");
$nFormField->Caption = "Choose whether this duplicate is a separate COPY or a CLONE (e.g. update it here and it updates on both pages).";
$nFormField->RowStyle = "clear:both;float:none;";
$nFormField->DataARRAY = array(
	"COPY" => "Copy",
	"CLONE" => "Clone");
$nFormField->SelectedARRAY = array("COPY" => "checked");
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormGroup1->AddField($nFormField);

// Finalize and display form
$nForm1->AddGroup($nFormGroup1);
$nFormToDisplay = $nForm1->GetForm();

// AJAX redirect if form submitted w/o error, otherwise display form (again, if necessary)
if($nForm1->HasProcessed){
	$nRecID = $_POST["id"]; // component record to duplicate
	$nComponentID = $_POST["nComponentID"];
	$nPageIDARRAY = explode(",",$_POST["nPageID"]);
	$nColumnID = $_POST["nColumnID"];
	$nContentID = $_POST["nContentID"];
	$nXCompOrderID = $_POST["nXCompOrderID"];
	$nDuplicateType = $_POST["nDupType"];
	foreach($nPageIDARRAY AS $nPageID){
		switch($nDuplicateType){
			case "COPY":
				// Get existing component content data
				$nSQL = "SELECT * FROM nContent WHERE nID='$nContentID' LIMIT 1";
				$Result = mysql_db_query ($DBName,$nSQL,$Link);
				if($Row = mysql_fetch_array($Result)){
					$nText = $Row["nText"];
					$nTextarea = $Row["nTextarea"];
					$nImgID = $Row["nImgID"];
					$nLinkID = $Row["nLinkID"];
					$nOrderID = $Row["nOrderID"];
				}
				// Create new row in nContent for this component copy
				$Query = "INSERT INTO nContent (nText,nTextarea,nImgID,nLinkID) VALUES ('$nText','$nTextarea',$nImgID,$nLinkID)";
				mysql_select_db($DBName);
				mysql_query($Query, $Link);
				$nNewContentID = mysql_insert_id(); // gets ID of last created row
				// Create new component
				$Query = "INSERT INTO xComponentPage (nComponentID,nPageID,nColumnID,nContentID,nOrderID) VALUES ($nComponentID,$nPageID,$nColumnID,$nNewContentID,$nXCompOrderID)";
				mysql_select_db($DBName);
				mysql_query($Query, $Link);
				
				// Copy to additional language fields (default language already saved)
				if($nContentID && count($nActiveLangARRAY)){
					foreach($nActiveLangARRAY as $nLangCode => $nLangName) {
						$nType = "comp";
						$nContentARRAY = nGetContentARRAY($nContentID,$nLangCode,$nType);
						// if default language is not used, get translation from additional fields
						foreach($nContentARRAY AS $nOrderID => $nContentItemARRAY){
							$nText = addslashes($nContentItemARRAY["nText"]);
							$nTextarea = addslashes($nContentItemARRAY["nTextarea"]);
							$nImgID = $nContentItemARRAY["nImgID"];
							$nLinkID = $nContentItemARRAY["nLinkID"];
							// now save new content
							if($nNewContentID){
								$Query = "INSERT INTO nTranslate VALUES ('','$nLangCode','$nNewContentID','$nType','$nText','$nTextarea','$nLinkID','$nImgID','$nOrderID')";
								mysql_select_db($DBName);
								mysql_query($Query, $Link);
							}
						}
					}
				}
				break;
			case "CLONE":
				// Create new component
				$Query = "INSERT INTO xComponentPage (nComponentID,nPageID,nColumnID,nContentID) VALUES ($nComponentID,$nPageID,$nColumnID,$nContentID)";
				mysql_select_db($DBName);
				mysql_query($Query, $Link);
				break;
		}
	}
	if(count($nPageIDARRAY)>1){
		echo "<div align=\"center\" id=\"buttonBox\"><BR>";
			echo "<strong>Component succesfully duplicated on ".count($nPageIDARRAY)." pages!</strong><BR><BR>";
			echo "<input type=\"button\" name=\"nClose\" value=\"Close\" onClick=\"$.colorbox.close();\" class=\"formCancel\"> ";
		echo "</div>";
		echo "<script>$nRefreshCall $.colorbox.resize();</script>";
	} else {
		echo "<div align=\"center\" id=\"buttonBox\"><BR>";
			echo "<strong>Component has been succesfully duplicated!</strong><BR><BR>";
			echo "What do you want to do next?<BR><BR>";
			echo "<input type=\"button\" name=\"nEdit\" value=\"Go to Duplicate\" onClick=\"document.location.href='page_edit.php?id=".$_POST["nPageID"]."'\" class=\"formSubmit\"> ";
			echo "<input type=\"button\" name=\"nClose\" value=\"Close\" onClick=\"$.colorbox.close();\" class=\"formCancel\"> ";
		echo "</div>";
		echo "<script>$nRefreshCall $.colorbox.resize();</script>";
	}
} else {
	echo $nFormToDisplay;
	echo "<script>$.colorbox.resize();</script>";
}
?>
</div>

<?php
function nGetContentARRAY($nContentID,$nTranslateLang="",$nType="comp"){
	global $DBName,$Link,$nDefaultLang,$nSFLang;
	if(!$nContentID || !is_numeric($nContentID)){ return; }
	if(!$nTranslateLang){ $nTranslateLang = $nSFLang; }
	$nContentARRAY = array();
	$Query = "SELECT * FROM nTranslate WHERE nItemID='$nContentID' AND nLang='$nTranslateLang' AND nType='$nType'";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	while($Row = mysql_fetch_array($Result)) {
		$nOrderID = $Row["nOrderID"];
		$nContentCompARRAY = array();
		$nContentCompARRAY["nText"] = stripslashes($Row[nText]);
		$nContentCompARRAY["nTextarea"] = stripslashes($Row[nTextarea]);
		$nContentCompARRAY["nLinkID"] = stripslashes($Row[nLinkID]);
		$nContentCompARRAY["nImgID"] = $Row["nImgID"];
		// Add to main array
		$nContentARRAY[$nOrderID] = $nContentCompARRAY;
	}
	return $nContentARRAY;
}

function nGetComponentName($nRecID){
	global $DBName,$Link;
	$nSQL = "SELECT nName FROM nComponent WHERE nID='$nRecID' LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nName = $Row["nName"];
	}
	return $nName;
}

function nGetPageARRAY(){
	global $DBName,$Link;
	global $nRecID;
	$nDataARRAY = array();
	$nSQL = "SELECT nID,nNavTitle FROM nPage WHERE nType!='Link' ORDER BY nType,nSectionID,nOrderID";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	while($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"];
		$nNavTitle = $Row["nNavTitle"];
		$nDataARRAY["$nID"] = "$nNavTitle";
	}
	return $nDataARRAY;
}

function nGetNextCompNum(){
	global $DBName,$Link;
	$nSQL = "SELECT Max(nID) AS nID FROM xComponentPage";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"] + 1;
	}
	return $nID;
}

function nGetNextContentNum(){
	global $DBName,$Link;
	$nSQL = "SELECT Max(nID) AS nID FROM nContent";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"] + 1;
	}
	return $nID;
}

// returns array of active storefront languages in alpha order, default will be first item in array 
function nGetLangActiveARRAY(){
	global $nDefaultLang;
	$nDefaultLangARRAY = array();
	$nLangARRAY = array();
	// Get all files in directory
	$path = "../../lang/";    
	$dir_handle = @opendir($path) or die("Unable to open $path");    
	while ($file = readdir($dir_handle)) {
		if($file == "." || $file == ".." || $file == "index.php" )
			continue;
		$nFileCode = str_replace(".php","",$file);
		if(!is_dir("$path$file/")){
			if(file_exists("$path$file")){ require("$path$file"); }
			if($nFileCode == $nDefaultLang){
				if($nLang){ $nDefaultLangARRAY["$nFileCode"] = $nLang; } // default language
			} else {
				if($nLang){ $nLangARRAY["$nFileCode"] = $nLang; }
			}
		}
	}
	closedir($dir_handle);
	krsort($nLangARRAY);
	foreach($nDefaultLangARRAY as $nLangCode => $nLangName) {
		$nLangARRAY["$nLangCode"] = $nLangName;
	}
	$nLangARRAY = array_reverse($nLangARRAY,true);
	return $nLangARRAY;
}
?>
<? require("../../inc/db_close.php"); ?>
